FoodTruck/FoodTruck/Models/HomeViewModel.cs
using FoodTruck.DATA;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace FoodTruck.Models
{
    public class HomeViewModel
    {
        public IList<Actualite> Actualites { get; set; }

        public IList<Produit> Produits { get; set; }

    }
}

FoodTruck/FoodTruck/Controllers/CatalogueController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Globalization;
using System.Linq;
using System.Linq.Expressions;
using System.Net;
using System.Web;
using System.Web.Http.Results;
using System.Web.Mvc;
using System.Web.Routing;
using FoodTruck.DATA;
using FoodTruck.Models;
using Microsoft.AspNet.Identity;

namespace FoodTruck.Controllers
{
    public class CatalogueController : Controller
    {
        private foodtruckEntitiesContext db = new foodtruckEntitiesContext();
        private  DateTime _today = DateTime.Now;
        private static readonly Expression<Func<Produit, ProduitDto>> AsProduitDTO = r => new ProduitDto
        {
            
        };
        // GET: Catalogue
        public ActionResult Index(int? SelectedRepasId, int? SelectedFamilleRepasId, DateTime? dateOrder = null )
        {
            // set default value
            var selectedDateOrder = dateOrder ?? DateTime.Now;
            Session["dateOrder"] = selectedDateOrder;
            Session["dateId"] = (int)selectedDateOrder.DayOfWeek;

            var vm = new CatalogueViewModel();
            vm.SelectedRepasId = SelectedRepasId ?? db.Repas.OrderBy(r => r.id_Repas).First().id_Repas;
            vm.SelectedFamilleRepasId = SelectedFamilleRepasId ?? db.Repas.Find(vm.SelectedRepasId).FamilleRepas.OrderBy(f => f.id_FamilleRepas).First().id_FamilleRepas;

            vm.Repas = db.Repas.Select( r => new RepasDto {
                id_Repas = r.id_Repas,
                FamilleRepas = r.FamilleRepas,
                heure_limite = r.heure_limite,
                imageurl = r.imageurl,
                isenabled = r.isenabled,
                libelle = r.libelle,
                selected = (vm.SelectedRepasId == r.id_Repas) ? true : false
            }).ToList();

            vm.FamilleRepas = db.Repas.Find(vm.SelectedRepasId).FamilleRepas
                .Select(f => new FamilleRepasDto { 
                    id_FamilleRepas = f.id_FamilleRepas,
                    imageurl = f.imageurl,
                    isenabled = f.isenabled,
                    libelle = f.libelle,
                    Produit = f.Produit,
                    Repas = f.Repas,
                    selected = (vm.SelectedFamilleRepasId == f.id_FamilleRepas) ? true : false
                })
                .OrderBy(f => f.id_FamilleRepas)
                .ToList() ;

            vm.Produits = db.Produit.Where(x => x.FamilleRepas.id_FamilleRepas == vm.SelectedFamilleRepasId)
                .Select(p => new ProduitDto { 
                    id_Produit = p.id_Produit,
                    id_FamilleRepas = p.id_FamilleRepas,
                    description = p.description,
                    disponibilite = p.disponibilite,
                    FamilleRepas = p.FamilleRepas,
                    image = p.image,
                    isenable = p.isenable,
                    libellecommercial = p.libellecommercial,
                    libelletechnique = p.libelletechnique,
                    prix_unitaire = p.prix_unitaire,
                    stock_dispo = p.stock_dispo,
                    quantite = 0,
                    composedId = vm.SelectedRepasId.ToString() + "_" + vm.SelectedFamilleRepasId + "_" + p.id_Produit
                })
                .ToList();

            foreach (var produit in vm.Produits)
            {
                produit.quantite = RetrieveQuantity(produit.id_Produit, selectedDateOrder);
            }

            return View(vm);
        }

        public int RetrieveQuantity(int idProduit, DateTime dateOrder)
        {
            if (User.Identity.IsAuthenticated) {
                var orderInProgress = db.Commande.FirstOrDefault(x => x.id_Utilisateur == db.Utilisateur.FirstOrDefault(u => User.Identity.Name.ToLower()== u.email.ToLower()).id_Utilisateur && x.dateCommande == dateOrder);
                if (orderInProgress != null)
                {
                    if (orderInProgress.Ligne_Commande.Count() == 0)
                        return 0;
                    else {
                        var selectedLine = orderInProgress.Ligne_Commande.FirstOrDefault(l => l.id_Produit == idProduit);
                        if (selectedLine == null)
                            return 0;
                        else
                            return int.Parse(selectedLine.quantite.ToString());
                    }
                }
                else { 
                    return 0;
                }

            }else
                return 0;
        }

        public ActionResult Panier() {
            return View(db.Commande.Include(x => x.Ligne_Commande)
                    .FirstOrDefault(x => x.id_Utilisateur == db.Utilisateur.FirstOrDefault(u => User.Identity.Name.ToLower() == u.email.ToLower()).id_Utilisateur)            
                    );
        }

        public ActionResult ResetCart() { 
            var orderInProgress = db.Commande.FirstOrDefault(x => x.id_Utilisateur == db.Utilisateur.FirstOrDefault(u => User.Identity.Name.ToLower()== u.email.ToLower()).id_Utilisateur);

            orderInProgress.Ligne_Commande.Clear();

            db.Commande.Remove(orderInProgress);

            db.SaveChanges();

            return RedirectToAction("panier");
               
        }

        public ActionResult Detail(int id)
        {
            if (id <= 0)
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            
            var selectedProduct = db.Produit.Find(id);

            if (selectedProduct == null)
                return HttpNotFound();

            return View(selectedProduct);
        }
    }
}

FoodTruck/FoodTruck/Controllers/HomeController.cs
using FoodTruck.DATA;
using FoodTruck.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Entity;
using System.Web;
using System.Web.Mvc;

namespace FoodTruck.Controllers
{
    public class HomeController : Controller
    {
        private foodtruckEntitiesContext db = new foodtruckEntitiesContext();
        public ActionResult Index()
        {

            var vm = new HomeViewModel();
            vm.Actualites = db.Actualite.ToList();

            vm.Produits = db.Produit.Include(p => p.Ligne_Commande)
                                    .OrderByDescending(p => p.Ligne_Commande.Count)
                                    .Take(3)
                                    .ToList();

            return View(vm);
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}

FoodTruck/FoodTruck/Views/Home/About.cshtml
@{
    ViewBag.Title = "About";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<p>Use this area to provide additional information.</p>

FoodTruck/FoodTruck/Views/Home/Contact.cshtml
@{
    ViewBag.Title = "Contact";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong>   <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

FoodTruck/FoodTruck/Views/Home/Index.cshtml
@model FoodTruck.Models.HomeViewModel
@{
    ViewBag.Title = "Mon FoodTruck";
    ViewBag.Menu = "accueil";
    int count = 0;
}
<div style="height:auto; background-color: black;">

        <div id="carouselExampleIndicators" class="carousel slide" data-ride="carousel">
            <ol class="carousel-indicators">
                @foreach (var actualite in Model.Actualites)
                {
                    <li data-target="#carouselExampleIndicators" data-slide-to="@count" class="@(count == 0 ? "active" : "" )"></li>
                    count++;
                }
            </ol>
            @{ 
                count = 0;
            }
            <div class="carousel-inner">
                @foreach (var actualite in Model.Actualites)
                {
                    count++;
                    <div class="@(count == 1 ? "carousel-item active" : "carousel-item" )">
                        <img class="d-block w-100" src="@actualite.imageurl" alt="First slide">
                        <div class="carousel-caption d-none d-md-block">
                            <h5>@actualite.title</h5>
                            <p>@actualite.description</p>
                        </div>
                    </div>
                }
            </div>
            <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
                <span class="carousel-control-prev-icon" aria-hidden="true"></span>
                <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
                <span class="carousel-control-next-icon" aria-hidden="true"></span>
                <span class="sr-only">Next</span>
            </a>
        </div>

    <h3 class="text-center withThemeColor">Nos meilleurs ventes</h3>

    <div style="display: flex; flex-direction: row; justify-content: center; flex-wrap: nowrap;">
        @foreach (var produit in Model.Produits)
        {
            <div style="position: relative;">
                <div class="card " style="margin: 10px; border: 1px solid purple !important; min-width: 275px;max-width: 500px;">
                    <a href="@Url.Action("Detail", "Catalogue", new { id = produit.id_Produit })">
                        <img src="@produit.image" class="card-img-top" alt="@produit.libellecommercial" style="height : 175px;" >
                    </a>
                    <div class="card-body">
                        <p class="card-title withThemeColor">@produit.libellecommercial</p>
                        <div class="card-text spaceBetween">
                            <p> @produit.prix_unitaire €HT</p>
                            <p>
                                @{ var compteur = 0;}
                                @foreach (var item in produit.Ligne_Commande)
                                {
                                    compteur++;
                                    if (compteur <= 5)
                                    {
                                        <i class="fas fa-star" style="color:purple"></i>
                                    }
                                    else {
                                        break;
                                    }
                                }
                            </p>
                            <p class="withThemeColor">@Html.Raw(produit.prix_unitaire * 1.20) €TTC</p>
                        </div>
                   
                    </div>
                </div>
            </div>
        }
    </div>
</div>